unit HiUSBDrive;

interface

uses kol,Share,Debug,Windows,Messages,Hihttp_Get;

type

 THiUSBDrive = class(TDebug)
   private
    function GetVID_PID_SN(SymbolicName: String; var VID, PID: Word; 
                           Var SN, VName, PName: String): Byte;
    function Check(_data: TData; var Inst: DWORD): Byte; 
   public
   
    _event_onEnumDrives: THI_Event;
    _event_onGetUSBDriveInfo: THI_Event;
    _event_onSafeRemoveUSBDrive: THI_Event;
    _event_onGetVendorList: THI_Event;
    _event_onError: THI_Event;
        
    _data_Drive: THI_Event;
     
    _prop_Drive: string;
    _prop_IDtoText: Boolean;
    _prop_SkipFloppy: Boolean;
    
    procedure _work_doSafeRemoveUSBDrive(var _Data:TData; Index:word); 
    procedure _work_doGetUSBDriveInfo(var _Data:TData; Index:word);
    procedure _work_doEnumDrives(var _Data:TData; Index:word);
    procedure _work_doGetVendorList(var _Data:TData; Index:word);    
 end;
                 
implementation

const
  Drive_Type: array[0..6] of string = ('DRIVE_UNKNOWN','DRIVE_NO_ROOT_DIR',
     'DRIVE_REMOVABLE','DRIVE_FIXED','DRIVE_REMOTE','DRIVE_CDROM','DRIVE_RAMDISK');
  Err_Text: array[1..23] of string =(
    'VetoLegacyDevice','VetoPendingClose','VetoWindowsApp',
    'VetoWindowsService','VetoOutstandingOpen','VetoDevice.  ',
    'VetoDriver','VetoIllegalDeviceRequest.   ',
    'VetoInsufficientPower','VetoNonDisableable','VetoLegacyDriver',
    'VetoInsufficientRights','       ',
    '    DRIVE_REMOVABLE','  USB ', 
    '   ','  instance ','',
    '   ',
    '   ,      ',  
    '   ','   ',
    '   ');
  
  RegDisposition_OpenExisting = $00000001;   
  DIGCF_PRESENT = $00000002;
  DIGCF_DEVICEINTERFACE = $00000010;
  ANYSIZE_ARRAY = 1;
  MAX_DRIVES = 26;

const
       //     - Veto
  
  VetoLegacyDevice         = 1;   
  VetoPendingClose         = 2;   
  VetoWindowsApp           = 3;   
  VetoWindowsService       = 4;   
  VetoOutstandingOpen      = 5;  
  VetoDevice               = 6;
  VetoDriver               = 7; 
  VetoIllegalDeviceRequest = 8; 
  VetoInsufficientPower    = 9; 
  VetoNonDisableable       = 10; 
  VetoLegacyDriver         = 11; 
  VetoInsufficientRights   = 12;  
      //   
  errNoError               = 0;
  errSyntaxError           = 13;  //        
  errIsNotRemovableDrive   = 14;  //    DRIVE_REMOVABLE 
  errIsNotUSBDevice        = 15;  //   USB  
  errDriveNotPresent       = 16;  //     
  errInvalidInstance       = 17;  //   instance 
  errGetVendorList         = 19;  //    
  errNotFoundVendorListFile= 20;  //    ,        
  errInvalidSymbolicName   = 21;  //    
  errUnknownVID            = 22;  //    
  errUnknownPID            = 23;  //    
  
type

  PSPDeviceInterfaceDetailData = ^TSPDeviceInterfaceDetailData;
  TSPDeviceInterfaceDetailData = packed record
    cbSize: DWORD;
    DevicePath: array [0..ANYSIZE_ARRAY - 1] of AnsiChar;
  end;
  
  PSPDevInfoData = ^TSPDevInfoData;
  TSPDevInfoData = packed record
    cbSize: DWORD;
    ClassGuid: TGUID;
    DevInst: DWORD; 
    Reserved: Longword;
  end;

  PSPDeviceInterfaceData = ^TSPDeviceInterfaceData;
  TSPDeviceInterfaceData = packed record
    cbSize: DWORD;
    InterfaceClassGuid: TGUID;
    Flags: DWORD;
    Reserved: Longword;
  end;
 
var
  kernel32: THandle=0;
  cfgmgr32: THandle=0;
  cfgmgr32load: Boolean=false;
  SetupApiLib: THandle=0;
  SetupApiLibLoad: Boolean=false;
  InitOk: Boolean=false;

  GetVolumeNameForVolumeMountPoint: function(lpszVolumeMountPoint: LPCTSTR;
                 lpszVolumeName: LPTSTR; cchBufferLength: DWORD): BOOL; stdcall;
  CM_Get_Device_ID: function(dnDevInst: DWORD; Buffer: PAnsiChar;
                    BufferLen: ULONG; ulFlags: ULONG): DWORD; stdcall;
  CM_Get_Device_ID_Size: function(var ulLen: ULONG; dnDevInst: DWORD; 
                         ulFlags: ULONG): DWORD; stdcall;
  CM_Open_DevNode_Key: function(dnDevNode: DWORD; samDesired: REGSAM;
                       ulHardwareProfile: ULONG; Disposition: PULONG;
                       var hkDevice: HKEY; ulFlags: ULONG): DWORD; stdcall;
  CM_Get_Parent: function(var dnDevInstParent: DWORD;
                 dnDevInst: DWORD; ulFlags: ULONG): DWORD; stdcall;
  CM_Request_Device_Eject: function(dnDevInst: DWORD; pVetoType: PDWORD;    
   pszVetoName: PAnsiChar; ulNameLength: ULONG; ulFlags: ULONG): DWORD; stdcall;
                     
  SetupDiGetClassDevs: function(ClassGuid: PGUID; const Enumerator: PAnsiChar;
                       hwndParent: HWND; Flags: DWORD): Pointer; stdcall;                    
  SetupDiEnumDeviceInterfaces: function (DeviceInfoSet: Pointer;
     DeviceInfoData: PSPDevInfoData; const InterfaceClassGuid: TGUID;
     MemberIndex: DWORD; var DeviceInterfaceData: TSPDeviceInterfaceData): BOOL; stdcall;
  
  SetupDiGetDeviceInterfaceDetail: function(DeviceInfoSet: Pointer;
     DeviceInterfaceData: PSPDeviceInterfaceData;
     DeviceInterfaceDetailData: PSPDeviceInterfaceDetailData;
     DeviceInterfaceDetailDataSize: DWORD; var RequiredSize: DWORD;
     Device: PSPDevInfoData): BOOL; stdcall;
     
  SetupDiDestroyDeviceInfoList: function(DeviceInfoSet: Pointer): BOOL; stdcall;
  
procedure freelibs;
begin
  if not InitOk then exit;
  if cfgmgr32Load then FreeLibrary(cfgmgr32);
  if SetupApiLibLoad then FreeLibrary(SetupApiLib);
end;

function loadprocs:boolean;
 function loadfunc(dllhandle:THandle; name:string):Pointer;
  begin
   result:=GetProcAddress(dllhandle,pchar(name));
  end;
begin
   Result := false;
   kernel32 := GetModuleHandle(PChar('kernel32.dll'));
   if kernel32 = 0 then exit;
   cfgmgr32 := GetModuleHandle(PChar('cfgmgr32.dll'));
   if cfgmgr32 = 0 then begin
      cfgmgr32 := LoadLibrary(PChar('cfgmgr32.dll'));
      cfgmgr32Load := true;
   end;
   if cfgmgr32 = 0 then exit;
   SetupApiLib := GetModuleHandle(PChar('SetupApi.dll'));
   if SetupApiLib = 0 then begin
      SetupApiLib := LoadLibrary(PChar('SetupApi.dll'));
      SetupApiLibLoad := True;
   end;
   if SetupApiLib = 0 then exit;
   
   @GetVolumeNameForVolumeMountPoint := loadfunc(kernel32, 'GetVolumeNameForVolumeMountPointA');
   @CM_Get_Device_ID := loadfunc(CfgMgr32, 'CM_Get_Device_IDA');
   @CM_Get_Device_ID_Size := loadfunc(CfgMgr32, 'CM_Get_Device_ID_Size');
   @CM_Open_DevNode_Key := loadfunc(CfgMgr32, 'CM_Open_DevNode_Key');
   @CM_Get_Parent := loadfunc(CfgMgr32, 'CM_Get_Parent');
   @CM_Request_Device_Eject := loadfunc(SetupApiLib, 'CM_Request_Device_EjectA');
   @SetupDiGetClassDevs := loadfunc(SetupApiLib, 'SetupDiGetClassDevsA');
   @SetupDiEnumDeviceInterfaces := loadfunc(SetupApiLib, 'SetupDiEnumDeviceInterfaces');
   @SetupDiGetDeviceInterfaceDetail := loadfunc(SetupApiLib, 'SetupDiGetDeviceInterfaceDetailA'); 
   @SetupDiDestroyDeviceInfoList := loadfunc(SetupApiLib, 'SetupDiDestroyDeviceInfoList');
   Result := true;
end;

function GetVolumeMountPoint(Name: string): string;
var
  Volume: array [0..MAX_PATH] of Char;
begin
  FillChar(Volume[0], SizeOf(Volume), 0);
  GetVolumeNameForVolumeMountPoint(PChar(Name), @Volume[0], SizeOf(Volume));
  Result := Volume;
end;

function GetDeviceID(Inst: DWORD): string;
var
  Buffer: LPTSTR;
  Size: ULONG;
begin
  CM_Get_Device_ID_Size(Size, Inst, 0);
  // Required! See DDK help for CM_Get_Device_ID
  Inc(Size);
  Buffer := AllocMem(Size * SizeOf(CHAR));
  CM_Get_Device_ID(Inst, Buffer, Size, 0);
  Result := Buffer;
  FreeMem(Buffer);
end;

// simple extraction of the bus name from DeviceID string

function ExtractBus(DeviceID: string): string;
begin
  Result := Copy(DeviceID, 1, Pos('\', DeviceID) - 1);
end;

// get the "SymbolicName" registry entry of a device
// for an USB device this string contains VID, PID and SerialNumber string
// example "\??\USB#Vid_08ec&Pid_0010#0918121014000B59#{a5dcbf10-6530-11d2-901f-00c04fb951ed}"

function GetSymbolicName(Inst: DWORD): string;
var
  Len: DWORD;
  Key: HKEY;
  // a hopefully sufficiently large buffer
  Buffer: array [0..4095] of Char;
begin
  CM_Open_DevNode_Key(Inst, KEY_READ, 0,
    PULONG(RegDisposition_OpenExisting), Key, 0);
  Buffer[0] := #0;
  if Key <> INVALID_HANDLE_VALUE then
  begin
    Len := SizeOf(Buffer);
    RegQueryValueEx(Key, 'SymbolicName', nil, nil, @Buffer[0], @Len);
    RegCloseKey(Key);
  end;
  Result := Buffer;
end;

function ExtractSerialNumber(SymbolicName: string): string;
var
  N: Integer;
begin
  N := Pos('#', SymbolicName);
  if N >= 0 then
  begin
    SymbolicName := Copy(SymbolicName, N + 1, Length(SymbolicName));
    N := Pos('#', SymbolicName);
    if N >= 0 then
    begin
      SymbolicName := Copy(SymbolicName, N + 1, Length(SymbolicName));
      N := Pos('#', SymbolicName);
      if N >= 0 then
        Result := Copy(SymbolicName, 1, N - 1)
      else
        Result := '';
    end;
  end
  else
    Result := '';
end;

// find the "bus" DeviceID for a given mount point

function GetDriveInstanceID(MountPointName: string; var DeviceInst: DWORD): Boolean;
const
  GUID_DEVINTERFACE_VOLUME: TGUID = '{53f5630d-b6bf-11d0-94f2-00a0c91efb8b}';
var
  StorageGUID: TGUID;
  PnPHandle: Pointer;
  DevData: TSPDevInfoData;
  DeviceInterfaceData: TSPDeviceInterfaceData;
  FunctionClassDeviceData: PSPDeviceInterfaceDetailData;
  Success: LongBool;
  Devn: Integer;
  BytesReturned: DWORD;
  Inst: DWORD;
  S, MountName: string;
begin
  Result := False;
  DeviceInst := 0;
  // enumerate all volumes
  StorageGUID := GUID_DEVINTERFACE_VOLUME;
  PnPHandle := SetupDiGetClassDevs(@StorageGUID, nil, 0, DIGCF_PRESENT or DIGCF_DEVICEINTERFACE);
  if PnPHandle = Pointer(INVALID_HANDLE_VALUE) then Exit;
  Devn := 0;
  repeat
    DeviceInterfaceData.cbSize := SizeOf(TSPDeviceInterfaceData);
    Success := SetupDiEnumDeviceInterfaces(PnPHandle, nil, StorageGUID, Devn, DeviceInterfaceData);
    if Success then
    begin
      DevData.cbSize := SizeOf(DevData);
      BytesReturned := 0;
      SetupDiGetDeviceInterfaceDetail(PnPHandle, @DeviceInterfaceData, nil, 0, BytesReturned, @DevData);
      if (BytesReturned <> 0) and (GetLastError = ERROR_INSUFFICIENT_BUFFER) then
      begin
        FunctionClassDeviceData := AllocMem(BytesReturned);
        try
          FunctionClassDeviceData.cbSize := SizeOf(TSPDeviceInterfaceDetailData);
          if SetupDiGetDeviceInterfaceDetail(PnPHandle, @DeviceInterfaceData,
            FunctionClassDeviceData, BytesReturned, BytesReturned, @DevData) then
          begin
            // get the grandparent DevNode which is the "bus" device
            // like "USB". This is the DevNode for CM_Request_Device_Eject and
            // several other useful operations
            Inst := DevData.DevInst;
            CM_Get_Parent(Inst, Inst, 0);
            CM_Get_Parent(Inst, Inst, 0);
            S := '\';
            S := LPTSTR(@FunctionClassDeviceData.DevicePath) + S;
            MountName := GetVolumeMountPoint(S);
            if MountName = MountPointName then
            begin
              DeviceInst := Inst;
              Result := True;
              Exit;
            end;
          end;
        finally
          FreeMem(FunctionClassDeviceData);
        end;
      end;
    end;
    Inc(Devn);
  until not Success;
  SetupDiDestroyDeviceInfoList(PnPHandle);
end;

// ================  ========
procedure dtVariant(var Data:TData; Value: Variant);
begin
  Case VarType(Value) and VarTypeMask of
    varByte, varSmallint, varInteger : dtInteger(Data, Value);
    varSingle, varDouble, varCurrency: dtReal(Data, Value);
    varString, varOleStr             : dtString(Data, Value);
  end;
end;

procedure _hi_onEventV(const PointEvent:THI_Event; Values: Variant); //overload;
 var i: Integer;                         
     data: Array of TData;
begin
  SetLength(data, VarArrayHighBound(Values,1)+1);
  for i:=0 to VarArrayHighBound(Values,1)-1 do begin
       dtVariant(data[i],Values[i]);
       data[i].lData:=@data[i+1];
  end;
  dtVariant(data[i],Values[i]);
  _hi_onEvent(PointEvent, data[0]);
  data:=nil;  
end;
 
procedure _hi_onEvent(const PointEvent:THI_Event; Values: array of string); overload;
 var i: Integer;
     data: Array of TData;
begin
//  _hi_onEventV(PointEvent, Variant(Values));
  SetLength(data, length(Values));
  for i:=0 to High(Values)-1 do begin
       dtString(data[i],Values[i]);
       data[i].lData:=@data[i+1];
  end;   
  dtString(data[i],Values[i]);
  _hi_onEvent(PointEvent, data[0]);
  data:=nil;  
end;

// ====================================
procedure THiUSBDrive._work_doEnumDrives;
var i: Integer;
    dwDriveMask: DWORD;
    DriveName: string;
  	VolName,FSName:array [0..MAX_PATH-1] of Char; 
	VolSN,MC,FSF: DWord; 
begin
  dwDriveMask := GetLogicalDrives;
  DriveName := 'A:\';
  for i := 0 to MAX_DRIVES - 1 do
    if (dwDriveMask and (1 shl i)) <> 0 then
    begin
      DriveName[1] := Chr(65+i);
      VolName[0]:=#0; FSName[0]:=#0; VolSN:=0; 
      if _prop_SkipFloppy and (i>1) or not _prop_SkipFloppy then 
         GetVolumeInformation(PChar(DriveName),VolName,MAX_PATH,@VolSN,MC,FSF,FSName,MAX_PATH);
      _hi_onEvent(_event_onEnumDrives, 
                   [DriveName,
                    Drive_Type[GetDriveType(PChar(DriveName))],
                    FSName,
                    VolName, 
                    int2hex(VolSN,0), 
                    GetVolumeMountPoint(DriveName)]);
    end;
end;

procedure THiUSBDrive._work_doSafeRemoveUSBDrive;
var Inst, VetoType: DWORD;
    VetoName: Array [0..260] of Char;
    err: Byte;
begin
  VetoType := 0;
  VetoName :=#0;
  err:=Check(_Data, Inst);
  if err=errNoError then begin
    CM_Request_Device_Eject(Inst, @VetoType, @VetoName, 260, 0);
    if VetoType = 0 then _hi_onEvent(_event_onSafeRemoveUSBDrive) 
                    else err := VetoType; 
  end; 
  if err>errNoError then 
     _hi_onEventV(_event_onError,VarArrayOf([err, Err_Text[err], string(VetoName)])); 
end;

procedure THiUSBDrive._work_doGetUSBDriveInfo;
var Inst: DWORD;
    Err: Byte;
    VID,PID: Word;
    SN,VName,PName: String;
begin
  err:=Check(_Data, Inst);
  if err=errNoError then begin 
      err:=GetVID_PID_SN(GetSymbolicName(Inst),VID,PID,SN,VName,PName);
      _hi_onEventV(_event_onGetUSBDriveInfo, VarArrayOf([VID, PID, SN, VName, PName]));
  end;    
  if err>errNoError then
      _hi_onEventV(_event_onError, VarArrayOf([err, Err_Text[err]]));
end;

function THiUSBDrive.Check(_data: TData; var Inst: DWORD): Byte;
var DriveName: String;
    DriveType: Byte;
    MountPoint: String;
    dwDriveMask: DWORD;
begin
  Result:=errNoError;
  DriveName := UpperCase(ReadString(_Data, _data_Drive, _prop_Drive));
  if (Length(DriveName)>0) and (DriveName[1] in ['A'..'Z']) then //  
   begin
     DriveName := DriveName[1]+':\';
     dwDriveMask := GetLogicalDrives;
     if (dwDriveMask and (1 shl (byte(DriveName[1])-65))) <> 0 then
     begin
       DriveType := GetDriveType(PChar(DriveName));
       if DriveType = DRIVE_REMOVABLE then 
       begin
         MountPoint := GetVolumeMountPoint(DriveName);
         if GetDriveInstanceID(MountPoint, Inst) then begin
           if ExtractBus(GetDeviceID(Inst)) <> 'USB' then
             Result:=errIsNotUSBDevice; 
         end else 
            Result:=errInvalidInstance;  
       end else Result:=errIsNotRemovableDrive;
     end else Result:=errDriveNotPresent;
   end else Result:=errSyntaxError;  
end;

procedure THiUSBDrive._work_doGetVendorList;
var p: pStream;
    st: PStrList;
    i,k: integer;
    Vi, Pi: DWord;
    d: THIHTTP_Get;
    s,ss: String;
begin
  d:=THIHTTP_Get.Create;
  with d do begin
    _prop_URL := PChar('http://www.linux-usb.org/usb.ids'#0);
    _prop_FileName := PChar('usb.tmp'#0);
    _prop_Wait := True;
    _prop_Proxy := PChar(#0);
    _prop_ProxyUsername := PChar(#0);
    _prop_ProxyPassword := PChar(#0);
    _work_doDownload(_data_empty,0);
    Destroy;
  end;
 
  If FileSize('usb.tmp')>0 then begin
    p:=newReadFileStream('usb.tmp');
    st:=NewStrList;
    st.SetUnixText(p.ReadStrZ, true);
    p.free;
    p:=newWriteFileStream('usb.ids');
    while copy(st.ItemPtrs[0],1,1)='#' do st.Delete(0);
    k:=0;  
    For i:=0 to st.Count-1 do begin
      s:=st.Items[i];
      if s[1]='#' then Break;
      case k of 
        0: if s[1]<>#9 then begin
             Vi:=hex2int(copy(s,1,4));
             p.Write(Vi,4);
             s:=CopyEnd(s,7);
             p.WriteStrPas(s);
             k:=1;
           end; 
        1: if (s[1]=#9) then begin
             Vi:=hex2int(copy(s,2,4)) shl 16;
             p.Write(Vi,4);
             s:=CopyEnd(s,8);
             p.WriteStrPas(s);
           end else k:=0; 
      end;
    end;  
    p.free;
    st.free;
    DeleteFiles('usb.tmp');
    _hi_onEvent(_event_onGetVendorList);
  end else
    _hi_onEventV(_event_onError, VarArrayOf(
             [errGetVendorList,Err_Text[errGetVendorList]]));
end;

Function THiUSBDrive.GetVID_PID_SN;
var VendorList: PStream;
    s: String;
    VW,PW: Word;
    i,k: Integer;
  Procedure skipStr;
   Begin
     VendorList.Read(i,1);
     VendorList.Position:=VendorList.Position+i;
   End;  
begin
  Result:=0; 
  VID:=0; PID:=0; SN:=''; VName:=''; PName:='';
  SymbolicName:=LowerCase(SymbolicName);
  i:=Pos('vid_', SymbolicName);
  k:=Pos('pid_', SymbolicName);
  if (i=0) or (k=0) then 
    begin Result:=errInvalidSymbolicName; exit; end;
  VID:=Hex2Int(Copy(SymbolicName, i + 4, 4));
  PID:=Hex2Int(Copy(SymbolicName, k + 4, 4));
  SN:=ExtractSerialNumber(SymbolicName);
  if _prop_IDtoText then begin
    if FileSize('usb.ids')>0 then begin
      VendorList:=NewReadFileStream('usb.ids');
      k:=0;    
      while VendorList.Position<VendorList.Size do begin
        VendorList.Read(VW,2);
        VendorList.Read(PW,2);
        case k of 
          0: if (VW=VID) then begin 
               VName:=VendorList.ReadStrPas; k:=1; 
             end else skipStr; 
          1: if (VW=0) then  
               if (PW=PID) then begin 
                 PName:=VendorList.ReadStrPas; break; 
               end else skipStr;
              else begin 
               Result:=errUnknownPID; 
               break; 
             end;
        end;        
      end;
      if k=0 then Result:=errUnknownVID; 
      VendorList.free;
    end else Result:=errNotFoundVendorListFile; 
  end;
end;

initialization

 InitOk:=loadprocs;
 if not InitOk then msgOk('     USBDrive');
 
finalization
 
 freelibs;
 
end.